<?php
// Update the Moodle grade
function rawSendGrade($sourcedid, $oauth_consumer_key, $oauth_consumer_secret, $grade, $endpoint) {
	$operation = 'replaceResultRequest';
	$postBody = str_replace(
		array('SOURCEDID', 'GRADE', 'OPERATION','MESSAGE'), 
		array($sourcedid, $grade, $operation, uniqid()), 
		getPOXGradeRequest()
	);

	$content_type = 'application/xml';
	$response = sendOAuthBodyPOST('POST', $endpoint, $oauth_consumer_key, $oauth_consumer_secret, $content_type, $postBody);
}

// Read the Moodle grade
function rawGetGrade($sourcedid, $oauth_consumer_key, $oauth_consumer_secret, $endpoint) {
	$operation = 'readResultRequest';
	$postBody = str_replace(
		array('SOURCEDID', 'OPERATION','MESSAGE'), 
		array($sourcedid, $operation, uniqid()), 
		getPOXRequest()
	);

	$content_type = 'application/xml';
	$response = sendOAuthBodyPOST('POST', $endpoint, $oauth_consumer_key, $oauth_consumer_secret, $content_type, $postBody);
	
	try { 
    	$retval = parseResponse($response);
	} catch(Exception $e) {
    	$retval = $e->getMessage();
	}
	$grade = $retval['textString'];
	return $grade;
}

// Format the grade
function formatGrade($grade) {
	return round($grade * 100) . '%';
}

// Get parameters
$sourcedid = urldecode($_POST['lis_result_sourcedid']);
$oauth_consumer_key = urldecode($_POST['oauth_consumer_key']);
$lis_outcome_service_url = urldecode($_POST['lis_outcome_service_url']);
$oauth_consumer_secret = 'secret';

// Update grade
function sendGrade($grade) {
	global $sourcedid, $oauth_consumer_key, $oauth_consumer_secret, $lis_outcome_service_url;
	rawSendGrade($sourcedid, $oauth_consumer_key, $oauth_consumer_secret, $grade, $lis_outcome_service_url);
}

// Get grade
function getGrade() {
	global $sourcedid, $oauth_consumer_key, $oauth_consumer_secret, $lis_outcome_service_url;
	return rawGetGrade($sourcedid, $oauth_consumer_key, $oauth_consumer_secret, $lis_outcome_service_url);
}